<template>
  <v-container>
    <v-row>
      <v-col cols="5">
      </v-col>
      <v-col cols="7">
        <h1>User Active</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="userActives"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon
                small
                v-if="getAccessToken !== item.token && $store.getters.getRoles.includes('SUPER_ADMIN_WEB') && item.roles.includes('SUPER_ADMIN_WEB')"
                @click="doDelete(item)">mdi-delete
            </v-icon>
            <v-icon
                small
                v-else-if="getAccessToken !== item.token && $store.getters.getRoles.includes('ADMIN_WEB') && !item.roles.includes('SUPER_ADMIN_WEB')"
                @click="doDelete(item)">mdi-delete
            </v-icon>
            <v-card-text
                v-else-if="getAccessToken === item.token">
              Current
            </v-card-text>
            <v-card-text
                v-else>
              Cannot Terminate
            </v-card-text>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import userActiveService from "../service/UserActiveService"
import {getAccessToken} from "../utils/util";

const moment = require('moment')
const dateformat = require('dateformat')

export default {
  name: "UserActive",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      userActives: [],
      title: null,
      headers: [
        {text: "ACTION", align: "center", value: "actions", sortable: false },
        {
          text: "USERNAME", align: "center", sortable: true, value: "username", sort: function (a, b) {
            return a < b
          }
        },
        {text: "LAST LOGIN", align: "center", value: "last_login", sortable: true},
        {text: "ACTIVE LOGIN", align: "center", value: "active", sortable: true},
        {text: "ROLES", align: "center", value: "roles", sortable: true},
        {text: "IP CLIENT", align: "center", value: "ip_address", sortable: true},
      ],
      dialogAdd: false,
      statusProgress: false,
      getAccessToken: null,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doRefresh() {
      this.statusProgress = true
      await userActiveService.getAll().then(res => {
        if (res.data.status === 'SUCCESS') {
          this.userActives = res.data.data
          for (let userActive of this.userActives) {
            let date = userActive.last_login
            userActive.last_login = dateformat(date, 'dddd, mmmm dS, yyyy, HH:MM:ss')
            userActive.active = `${moment(date).fromNow(true)} ago`

            let roles = []
            for (let role of userActive.roles) {
              roles.push(role.substring(5))
            }
            userActive.roles = roles
          }
        }
      })
      this.statusProgress = false
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Logout Paksa USER ${data.username}`)) {
        return false;
      }
      this.statusProgress = true
      await userActiveService.delete(data.id).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
      })
      this.statusProgress = false
    },
  },
  async mounted() {
    this.getAccessToken = getAccessToken()
    await this.doRefresh()
  }
}
</script>

<style scoped>

</style>